{ config, lib, pkgs, ... }:
{
  nix.settings.experimental-features = [ "nix-command" "flakes" ];

  users.users.access = {
    isNormalUser = true;
    home = "/home/access";
    # password = "4cc3ss";
    extraGroups = [ "wheel" "networkmanager" ];
    shell = pkgs.nushell;
    openssh.authorizedKeys.keys = [ "ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAIH31k4XJU6NYkDWKbsfQcHraO1b2rBX7jX3xSOtyLCK0 calliope@chesapeake" ];
  };

  users.users.root = {
    shell = pkgs.nushell;
    openssh.authorizedKeys.keys = [ "ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAIH31k4XJU6NYkDWKbsfQcHraO1b2rBX7jX3xSOtyLCK0 calliope@chesapeake" ];
  };

  services.openssh = { enable = true; settings.PermitRootLogin = "yes"; };
  networking.firewall = { enable = true; };
}
