{ nixos-hardware, home-manager, ... }@sources:
{
  # localSystem = "x86_64-linux";
  specialArgs = sources;

  #{ inherit sources; pkgs = sources.nixpkgs.lib.pkgs; };
  modules = [
    (import ../../module/login.nix {
      user = "calliope";
      command = "zellij -s home -l home";
    })

    "${nixos-hardware}/framework/13-inch/11th-gen-intel/default.nix"
    home-manager.nixosModules.default

    ./2024-06.dec.nix
    ./base.nix

    ../../module/hypr.nix
    ../../module/hypr/idle.nix
    ../../module/hypr/lock.nix
    ../../module/hypr/paper.nix
    ../../module/hypr/pypr.nix

    ../../home/record.nix
    ../../mach/base.nix
    ../../module/energy.nix
    ../../module/essence.nix
    ../../module/graphical.nix
    ../../module/language.nix
    ../../module/look.nix
    ../../module/mail.nix
    ../../module/media.nix
    ../../module/mesh.nix
    ../../module/micro.nix
    ../../module/muse.nix
    ../../module/package.nix
    ../../module/process.nix
    ../../module/session.nix
    ../../module/shell.nix
    ../../module/signal.nix
    ../../module/upgrade.nix

# ../../home/helix.nix
# ../../module/arduino.nix
# ../../module/game.nix
# ../../module/gnome.nix
# ../../module/screen.nix # displaylink usb driver, used by Asus ZenScreen
# ./module/disc.nix

  ];
}
