#!/bin/bash
set -e

echo "Preparing Ubuntu/Debian."
apt update
apt install -y \
  automake \
  bison \
  build-essential \
  bzip2 \
  caffeine \
  cargo \
  cmake \
  curl \
  docker-compose \
  elixir \
  ffmpeg \
  freeglut3 \
  freeglut3-dev \
  gcc \
  git \
  gnome-sushi \
  golang \
  gpaste \
  htop \
  ibus-pinyin \
  inkscape \
  jq \
  kde-cli-tools \
  kdeconnect \
  libgtk-3-dev \
  libhamlib-dev \
  libpulse-dev \
  libyaml-dev \
  make \
  mercurial \
  neovim \
  pandoc \
  postgresql \
  python-setuptools \
  python3 \
  python3-dev \
  python3-gpg \
  python3-pip \
  ripgrep \
  silversearcher-ag \
  snapd \
  sudo \
  sway \
  tree \
  vlc \
  wireshark \
  zellij \
  zip \

  # rust \
  # touchegg \
  # usb-creator-gtk \

  # podman \
  # podman-docker \
  # firefox-geckodriver \

# node
apt install -y dirmngr gawk gpg
# ruby
apt install -y autoconf bison patch build-essential rustc libssl-dev libyaml-dev libreadline6-dev zlib1g-dev libgmp-dev libncurses5-dev libffi-dev libgdbm6 libgdbm-dev libdb-dev uuid-dev

# systemctl enable podman.socket
# systemctl start podman.socket
systemctl enable postgresql
systemctl start postgresql

# cd ~/src
# rm -rf linux.dropbox.com || echo > /dev/null
# wget -r --accept-regex="\/dropbox.*_amd64.deb" https://linux.dropbox.com/packages/ubuntu/
# PACKAGE=$( ls ./linux.dropbox.com/packages/ubuntu/*.deb | grep '[0-9]\{4\}' | sort | tail -n 1)
# apt install -y $PACKAGE
